#define private public
#include <PSX/File/Processor/File_Processor.hpp>
#include <stdio.h>

namespace FileProcessor {
    union SimpleTIMState {
        State::Reserved _reserved;
        struct {
            uint32_t test;
        };

        constexpr SimpleTIMState(uint32_t test = 0) : test(test) {
        }
    };
    static_assert(sizeof(SimpleTIMState) <= sizeof(State::Reserved));

    static bool process(State::Configuration& config, SimpleTIMState& state, size_t size) {
        printf("Dino: %i\n", state.test);
        return false;
    }

    State create(const uint32_t* data_adr, const SimpleTIM& file) {
        SimpleTIMState test(123);
        
        return State{.config = State::Configuration::from(process, data_adr), .reserved = test._reserved};
    }
}

#undef private